#include <iostream>
#include <iomanip>
#include <string>
#include <math.h>
#include <assert.h>
#include <conio.h>
#include <time.h>
#include <windows.h>
#include <sstream>
#include <fstream>

#include "ship.h"

using namespace std;


enum e_key {
	KEY_UP=72,
	KEY_DOWN=80,
	KEY_LEFT=75,
	KEY_RIGHT=77,
	KEY_EXIT=120,
	KEY_HELP=63,
	KEY_POD=106,
	KEY_WAIT=119,
	KEY_TELEPORT=112,
	KEY_Y=121,
	KEY_N=110
};

struct point {
	long long x;
	long long y;
} sector;

const int ZONE_SIZE=15;

const int NUM_ADS=1;
const string AD[NUM_ADS]={
	"How much down-time do you encounter waiting on those buzzard collectors?  How much is that fuel guzzling old "
	"clunker of a ship affecting your profit margins?  Acquire a Prah class long range scout today and your travel "
	"troubles will be over!  The Prah is the fastest vessel available with a maximum speed of warp 12!  In addition "
	"it's fuel useage level is so low you may never again need to sit dead in space while your auto-pilot refuels you "
	"Look for the latest models of Prah class long range scouts at space ports everwhere!"
};

const int NUM_ITEMS=15;
struct t_merchItem {
	int index;
	string name;
	bool illicit;
	double valueBase;
	int quant;
	point acquireSector;
	double pricePaid;
	int type;
} merchItem[NUM_ITEMS];
enum e_itemTypes {
	i_merchant=0,
	i_loot=1,
	i_quest=2
};

const int NUM_FACTIONS=10;
const double MAX_FACTION=100;
enum e_faction {
	f_ferengi=0,
	f_federation=1,
	f_cardassian=2,
	f_bajorian=3,
	f_klingon=4,
	f_romulan=5,
	f_vulcan=6,
	f_breen=7,
	f_andorian=8,
	f_unknown=9
};
const double KOS_FACTION = -30;

struct t_faction {
	int index;
	string name;
	bool oppose[NUM_FACTIONS];
	bool ally[NUM_FACTIONS];
} raceFaction[NUM_FACTIONS];



const int SHIP_TYPES=6;
const string SHIP_NAME[SHIP_TYPES]={
	"Escape Pod",
	"Volnor Class Scout",
	"Latus Class Freighter",
	"Muktok Class Defender",
	"Divarin Class Cruiser",
	"Prah class long range scout"
};
const string SHIP_SYSTEM_NAME[5]={
	"Hull   ",
	"Shields",
	"Engines",
	"Weapons",
	"Comm.  "
};
enum e_shipSystem {
	s_hull,
	s_shields,
	s_engines,
	s_weapons,
	s_comm
};

struct shipStat {
	int index;
	string className;
	double fuel;
	double fuelUseage;
	int maxWarp;
	int currentWarp;
	int defense;
	int attack;
	int systemHealth[5];

	int cargoHold;
	int cargoItems;
	t_merchItem cargoItem[100];
	int itemStacks;

	point tpCoords;
	double value;
	long long age;

	point autoPilotCoords;
	bool autoPilotActive;
	bool autoPilotFastWarp;
};


const string ROA[159]={
	"The best deal is the one that brings the most profit.	",
	"Never spend more for an acquisition than you have to.	",
	"A woman wearing clothes is like a man in the kitchen.	",
	"If you can't break a contract, bend it.	",
	"Never allow family to stand in the way of opportunity.	",
	"Keep your ears open.	",
	"Small print leads to large risk.	",
	"Opportunity plus instinct equals profit.	",
	"Greed is eternal.	",
	"Even if it's free, you can always buy it cheaper.	",
	"Anything worth doing is worth doing for money.	",
	"Anything worth doing is worth doing twice.	",
	"Keep your family close, keep your Latinum closer.	",
	"Acting stupid is often smart.	",
	"A deal is a deal. (until a better one comes along).	",
	"A contract is a contract is a contract - but only between Ferengi.	",
	"A Ferengi without profit is no Ferengi at all.	",
	"Satisfaction is not guaranteed.	",
	"Only give money to people you know you can steal from.	",
	"Never place friendship before profit.	",
	"A wise man can hear profit in the wind.	",
	"Latinum can't buy happiness, but you can sure have a blast renting it.	",
	"There's always a way out.	",
	"As the customers go, so goes the wise profiteer.	",
	"There's nothing more dangerous than an honest businessman.	",
	"Whisper your way to success.	",
	"What's in it for me?	",
	"Talk is cheap; synthehol costs money.	",
	"Never make fun of a Ferengi's mother. (insult something he cares about, instead).	",
	"Be careful what you sell. It may do exactly what the customer expects.	",
	"It never hurts to suck up to the boss.	",
	"War is good for business.	",
	"Peace is good for business.	",
	"Too many Ferengi can't laugh at themselves anymore.	",
	"If it's free, take it and worry about hidden costs later.	",
	"Friendship is temporary; profit is forever.	",
	"She can touch your lobes, but never your Latinum.	",
	"Profit is its own reward.	",
	"What's mine is mine, and what's yours is mine too.	",
	"Caressing an ear is often more forceful than pointing a weapon.	",
	"Never confuse wisdom with luck.	",
	"Ambition knows no family.	",
	"Make your shop easy to find.	",
	"Don't trust a man wearing a better suit than your own.	",
	"The bigger the smile, the sharper the knife.	",
	"Everything is worth something to somebody.	",
	"Gratitude can bring on generosity.	",
	"Reward anyone who adds to your profits so they will continue to do so.	",
	"Never ask when you can take.	",
	"Good customers are as rare as Latinum, Treasure them.	",
	"There is no substitute for success.	",
	"Free advice is seldom cheap.	",
	"Keep your lies consistent.	",
	"Never buy what can be stolen.	",
	"The riskier the road, the greater the profit.	",
	"Win or lose, there's always Huyperian beetle snuff.	",
	"Ear stroking will get you anything.	",
	"Ferengi are not responsible for the stupidity of other races.	",
	"Get the money first, then let the buyers worry about collecting the merchandise.	",
	"There's a customer born every minute.	",
	"Never trust your customers.	",
	"If it gets you profit, sell your own mother.	",
	"Home is where the heart is, but the stars are made of Latinum.	",
	"Every once in a while, declare peace. It confuses the hell out of your enemies.	",
	"It's better to swallow your pride than to lose your profit.	",
	"When the going gets tough, the tough change the Rules.	",
	"Beware of the Vulcan greed for knowledge.	",
	"The flimsier the product, the higher the price.	",
	"A friend is not a friend if he asks for a discount.	",
	"Never let the competition know what you're thinking.	",
	"A friend in need means three times the profit.	",
	"Ask not what your profits can do for you, ask what you can do for your profits.	",
	"There are many paths to profit.	",
	"Act without delay! The sharp knife cuts quickly.	",
	"Females and finances don't mix.	",
	"Expand or die.	",
	"For every Rule, there is an equal and opposite Rule, (except when there's not).	",
	"Enough... is never enough.	",
	"Every man has his price.	",
	"Trust is the biggest liability of all.	",
	"If they take your first offer, you either asked too little or offered too much.	",
	"The only value of a collectible is what you can get somebody else to pay for it.	",
	"Nature decays, but Latinum lasts forever.	",
	"Sleep can interfere with...	",
	"Faith moves mountains... (of inventory).	",
	"Don't trust anyone who trusts you.	",
	"There is no honor in poverty.	",
	"A warranty is valid only if they can find you.	",
	"Dignity and an empty sack is worth the sack.	",
	"Treat people in your debt like family, exploit them [ruthlessly].	",
	"Never have sex with the boss' sister.	",
	"Always have sex with the boss.	",
	"The best contract always has a lot of fine print.	",
	"There's always a catch.	",
	"Everything is for sale, including friendship.	",
	"Never judge a customer by the size of his wallet, (...sometimes, good things come in small packages).	",
	"Everything is for sale, including friendship.	",
	"Even a blind man can recognize the glow of Latinum.	",
	"You can't make a deal if you're dead.	",
	"Count it.	",
	"Stay neutral in conflict so that you can sell supplies to both sides.	",
	"Never trust a beneficiary.	",
	"Wives serve, brothers inherit.	",
	"Only fools pay retail.	",
	"There's no such thing as an unfair advantage.	",
	"Risk is part of the game... play it for all it's worth.	",
	"There's nothing wrong with charity...as long as it winds up in your pocket.	",
	"Necessity, n. The mother of invention. Profit is the father.	",
	"A lie is a way to tell the truth to someone who doesn't know.	",
	"Sell the sizzle, not the steak.	",
	"Even in the worst of times, someone turns a profit.	",
	"Whisper your way to success.	",
	"Competition and fair play are mutually exclusive.	",
	"Blood is thicker than water, and Latinum is thicker than both.	",
	"Chances aren't what they used to be.	",
	"Know your enemies... but do business with them always.	",
	"Not even dishonesty can tarnish the shine of profit.	",
	"A fool and his money is the best customer.	",
	"Let others keep their reputation. You keep their money.	",
	"Hear all, trust nothing.	",
	"A Ferengi waits to bid until his opponents have exhausted themselves.	",
	"Never cheat a Klingon... unless you're sure you can get away with it.	",
	"It's always good business to know about new customers before they walk in your door.	",
	"If you're going to have to endure, make yourself comfortable.	",
	"The justification of profit is profit.	",
	"New customers are like razor-backed Gree worms... They can be succulent, but sometimes they bite back!	",
	"It takes a Ferengi to cheat a Ferengi.	",
	"Sometimes the only thing more dangerous than a question is an answer.	",
	"Employees are the rungs on the ladder of success... don't hesitate to step on them.	",
	"Never give away for free what can be sold.	",
	"Never begin a business negotiation on an empty stomach.	",
	"Never gamble with an empath.	",
	"You can't free a fish from water.	",
	"Always know what you're buying	",
	"Possession is 11/10 of the law.	",
	"Beware the man who doesn't make time for oo-mox.	",
	"Latinum lasts longer than lust.	",
	"There's a sucker born every minute; be sure you're the first to find each one.	",
	"You can't buy fate.	",
	"Never be afraid to mislabel a product.	",
	"Never trust a hardworking employee.	",
	"More is good... all is better.	",
	"Synthehol is the lubricant of choice for a customer's stuck purse.	",
	"A wife is a luxury... a smart accountant, a necessity.	",
	"Accountants do not play the game; they only keep the score.	",
	"Life's not fair. How else would you turn a profit?	",
	"A wealthy man can afford anything except a conscience.	",
	"A verbal contract isn't worth the paper it's written on.	",
	"Never allow doubt to tarnish your lust for Latinum.	",
	"The customer is always right, (...until you get their cash).	",
	"When in doubt, lie.	",
	"If you believe it, they believe it.	",
	"In business deals, a disruptor can be almost as important as a calculator.	",
	"Anything worth fighting for is worth hiding from.	",
	"Deep down, everyone's a Ferengi.	",
	"No good deed ever goes unpunished.	",
	"When Morn leaves, it's all over.	",
	"Whenever you exploit someone, it never hurts to thank them. That way, it's easier to exploit them the next time. (Neelix made this rule up)	",
	"When no appropriate Rule applies, make one up!	"
};
const int DOBBLE_PROB[10]={
	20,
	25,
	30,
	35,
	35,
	40,
	40,
	45,
	50,
	51
};

const long long FACTION_SECTOR_START_X[9]={
	400,
	-700,
	500,
	700,
	-500,
	-800,
	-600,
	500,
	200
};
const long long FACTION_SECTOR_START_Y[9]={
	300,
	-700,
	600,
	400,
	-1000,
	400,
	-100,
	-900,
	-200
};
const long long FACTION_SECTOR_SIZE[9]={
	200,
	500,
	400,
	200,
	300,
	600,
	400,
	700,
	300
};
	


const int MAX_MOBS=10;
struct t_mob {
	shipStat ship;
	point zoneCoords;
	int faction;
	bool hostile;
	bool active;
	point vector;
};

shipStat shipTemplate[SHIP_TYPES];
const long long MAX_TP_RANGE=10000;
const double SHIP_AGE_PRICE_MOD=.1;

struct barPeople {
	string name;
	int faction;
	int itemQuant[NUM_ITEMS];
	bool present;
};

struct stationStat {
	int securityLevel;
	double fuelCost;
	barPeople barPerson[5];
} currentStation;

struct spaceSector {
	int faction;
	bool hasWormhole;
	point whSector;
	string name;
	bool hasSpacePort;
	t_mob mob[MAX_MOBS];
} mySpaceSector;

struct cellItem {
	string name;
	int type;
	int colour;
} cellItem[ZONE_SIZE][ZONE_SIZE];

const double REFUEL_BASE=.1;
const double REPAIR_BASE=.3;

enum CELL_ITEM_TYPE {
	ci_none,
	ci_player,
	ci_border,
	ci_wormhole,
	ci_port,
	ci_otherShip,
	ci_hostileShip,
	ci_slash,
	ci_bslash,
	ci_openBracket,
	ci_closeBracket
};
const string CELL_ITEM_CHR[11]={
	" ",
	"^",
	"X",
	"O",
	"$",
	"V",
	"<",
	"/",
	"\\",
	"[",
	"]"
};

const double TIME_RATE=.01;
struct player {
	int shipType;
	shipStat ship;
	point zonePosition;
	double factionStanding[NUM_FACTIONS];
	double stardate;
	double funds;
	int lastClue;
	int numDrinks;
	int target;
} player;

const double TP_TICKET_PRICE=25.0;

const int NUM_CLUES=9;
const string CLUE[NUM_CLUES]={
	"I have been studying the cosmos nearly all my life.\n"
	"What appears to be a random chaotic mishmash of star systems, I believe, is not random at all! "
	"I am particularly interested in the black hole at the center of the galaxy. "
	"I believe that it's gravitational effects create the wormholes travelers such as yourself sometimes encouter. "
	"These wormholes appear to be more frequent near the center of the galaxy.",

	"A stable wormhole will take you to a predictable location and you can get back through "
	"the other end of the same wormhole.  However, an unstable wormhole will bring you to a "
	"completly unknown location and then collapse on you so that you cannot easily get back.",

	"Every wormhole has a period of stability, if you (w)ait long enough it will become stable.",

	"There must be some mathematical pattern to these wormholes, they are more common near "
	"the black hole at sector 0,0 and often show up in pairs.  If you find a wormhole there is a good "
	"chance that another one is only two sectors away.",

	"I believe there is a mathematical pattern to the placement of space ports as well.  "
	"However it seems to be different than the wormholes.  It has something to do with digit sums, I think.",

	"An object floating helplessly through space (such as an escape pod) will tend to be pulled "
	"toward the black hole at the center of the galaxy.  Should it end up there it would certainly be crushed. "
	"However, a passenger may get lucky and stumble across a space port before that happened.",

	"It's fun to explore space but try to make money while you're at it.  Keep in mind that some "
	"races will charge more to refuel or repair your vessel than others.",

	"Your ship's onboard buzzard collectors can refuel your ship while you (w)ait. "
	"They're slow, but in a pinch it'll keep you from being completly stranded.",

	"A Ferengi is a Ferengi, always.  Take that bar keep over there, even though he claims "
	"to just be a bar keep, I bet if you make him happy enough he'll do other business with you too."
};
void populateSector();
bool takeWormhole();
void doPause();
bool isPrime(long long theNum);
bool isSquare(long long theNum);
string genName(point theSector);
void showHelp();
string showPcent(int level);
bool burnFuel();
void escapePod();
int getFaction(point theSector);
long long calcDistance(point p1, point p2);
void drawZone(string shipStat[],int highStat);
void movePlayer(int direction);
void setWarpFactor(int factor);
bool confirm(string question);
void setShip(int index);
long long getControlNum();
void setCellItem(point coords, int type, int =15);

void generateCurrentStationStats();
void portMenu();
void mingleMenu();
void talkTo(int personNum);
void buyShipMenu(double priceMod);
void merchantInteract(int favor, int ctrlNumOffset);
void examineCargo();
bool addToCargo(t_merchItem item, int quant, double amountPaid);
void searchCargo();
void stationStores();
void save();
void load();
void moveMobs();
void doWait();
void makeZoneMobs();
double getExoticValue(point fromSector, point toSector);
void adjustFaction(int fIndex, double change);
void viewPlayerStats();
void autoPilot();
void drawScreen();

void checkFactions();
void useComputer();
void attackPlayer(int mobNum);
void toggleTarget();
void attackTarget();
void newZone();

enum colors
{
	black,	 blue,   green,   cyan,   red,   purple,   yellow,   white, 
	BRblack, BRblue, BRgreen, BRcyan, BRred, BRpurple, BRyellow, BRwhite
};

void setColor(int foreground, int background)
{
	int color=foreground;
	color+=(16*background);

	HANDLE hConsole;
	hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleTextAttribute(hConsole,color);
};
